// MFC_EditWithDADDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_EditWithDAD.h"
#include "MFC_EditWithDADDlg.h"
#include ".\mfc_editwithdaddlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CMFC_EditWithDADDlg dialog



CMFC_EditWithDADDlg::CMFC_EditWithDADDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_EditWithDADDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMFC_EditWithDADDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CMFC_EditWithDADDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CMFC_EditWithDADDlg message handlers

BOOL CMFC_EditWithDADDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// Subclass edit control. Notice that SubclassWindow is used that
	// allowes to use positionining of the edit control in the dialog 
	// template.
	m_ctlEditWithDAD.SubclassWindow(GetDlgItem(IDC_EDIT)->m_hWnd);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMFC_EditWithDADDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_EditWithDADDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMFC_EditWithDADDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

//------------------------------------------------------------------------------
// To enable dropping file to edit control CEditWithDAD is derived from CEdit
// and contents of EditWithDAD.h added to header, and the content of 
// EditWithDAD.cpp is appended here.

IMPLEMENT_DYNAMIC(CEditWithDAD, CEdit)
CEditWithDAD::CEditWithDAD(){}
CEditWithDAD::~CEditWithDAD(){}

BEGIN_MESSAGE_MAP(CEditWithDAD, CEdit)
	ON_WM_DROPFILES()
END_MESSAGE_MAP()

// Note: works for single files (edit mode) and for a folder (new collection).
void CEditWithDAD::OnDropFiles(HDROP hDropInfo)
{
	TCHAR szFFN[MAX_PATH];

	// MSDN (second parameter): "If the value of the iFile parameter is between 
	// zero and the total number of files dropped, DragQueryFile copies the file 
	// name with the corresponding value to the buffer pointed to by the 
	// lpszFile parameter."
	DragQueryFile(hDropInfo, 0 /* iFile */, szFFN, sizeof(szFFN)/sizeof(TCHAR)); 
	DragFinish(hDropInfo);

	// Update text in edit control.
	SetWindowText(szFFN);
}
